#ifndef _MC_SIMULATE
#define _MC_SIMULATE


int SRS_Simulate (Protein ** allNodes, int numberOfNodes, int startIndex, 
		   int maxIter, int foldedStateIndex, int unfoldedStateIndex);


   
int roulette_VP (const vector<float>&  probabilities);

/*
  does numIter iterations, with an interval of printInterval.
  starts from startP, and cyclic contains info. on whether the 
  parameters are cyclic.
*/
void MCSimulate(Protein * startP,double  numIter,  double printInterval, 
		const Protein * foldedState, const vector<bool> & cyclic,
		Protein ** allNodes);


//int MCSimulate(int startNodeIndex, Protein ** allNodes, const int maxIter,
//	       int  foldedStateIndex, int unfoldedStateIndex, float minRMSD);

int MCSimulate(int startNodeIndex, Protein ** allNodes, const unsigned int maxIter,
	       int  foldedStateIndex, int unfoldedStateIndex, 
	       float minRMSDFolded, float minRMSDUnfolded);
  //float minVecMidPtDist, float maxVecMidPtDistance, 
  //int vec1Index, int vec2Index);

/*
  starting  from node # startIndex. Does numMCSimulations  MC simulations;
  and computes pfold.
  writes results to 'pfold_%d.txt, startIndex'.
*/
void pFoldComputation (int foldedStateIndex, int unfoldedStateIndex, 
		       int numNodes, int startIndex,   
		       float minRMSDFolded,
		       float minRMSDUnfolded,
		       Protein ** allNodes);
#endif
