#ifndef IOROUTINES_H
#define IOROUTINES_H

enum DOF_Name { vectorAngle,  dihedralAngle , length, twistAngle};
#include <sys/times.h>
#include "protein.H"
#include <fstream>
using std::ofstream;
#include "matrix.H"

void readMyRoadmap    (int * numRandomNodes, int * numberOfNodes, 
		       const char * filename, 
		       Protein ** allNodes,  int runIndex);

void allocateNodes (int numNodes, Protein ** allNodes, int startIndex);
void writeMyRoadmap    (int numNodes, const char * filename, 
			Protein ** allNodes, int SAMPLES_PER_REGION,
			int SAMPLES_AROUND_GOAL, int MIN_REGIONS);
void insertConnection(int n1, int n2, float pW);
void doConnections4MyRoadmap(unsigned int numNodes);

void printEnergiesLine(ofstream * outFile, int node1, int node2, 
		       const vector<float> & newOrderedE);
void printEnergies(Protein ** allNodes, int numberOfNodes);
void readSomeNodesFromFile(const char *  roadmapFilename,
			   Protein  **   allNodes, 
			   int        *  numNodes, 
			   int inputStartIndex, int inputEndIndex);
void writeTransitionProbabilities(int numNodes, Protein ** allNodes, const char * filename);
void printRMSDs(Protein ** allNodes, int numberOfNodes);
void printIntArray(int * A, int numElements);
void printFloatArray(float * A, int numElements);
void printMatrix(mat4 m);
void printCloseNodeIndices (int foldedStateIndex, int unfoldedStateIndex,
			    float minRMSDFolded, float minRMSDUnfolded, 
			    Protein ** allNodes, int numNodes,
			    int runIndex);
void initialMessages();

void printParameters(int  numRandomNodes,       const char * protName,  
		     bool createNewRoadmap);

void handleInput (int argc, char ** argv, int * numRandomNodes,
		  char * relDir, char * protein_name,
		  char * roadmapFilename, int *startIndex, int * runIndex,
		  bool * createNewRoadmap, 
		  float * maxFoldedRMSDRadius,
		  float * maxUnfoldedRMSDRadius);
		  
		
void reportTimes (struct tms start, struct tms end);

void linkNodesStatPrintOuts(int numNodes, int numTrees, 
			    Protein ** allNodes, treeClass *globalFirstTree);

void printPfolds    (const vector<Real>  & pfolds, int numNodes, int runIndex);
#endif
