#ifndef ROADMAPCONSTRUCTION_H
#define ROADMAPCONSTRUCTION_H

#include "protein.H"

void initNativeStructure (int * numberOfNodes, const char * relDir, 
			  const char * protein_name, 
			  int endNodeIndex);
void initExtendedStructure(int * numberOfNodes, Protein * nativeP);

void linkNodes (int numNodes,
	       int runIndex, int k);
int makeLinkBetweenNodes (int numNodes, const int n1, const int n2, 
			  const float forwardPathWeight, 
			  const float backwardPathWeight) ;
bool try2Connect     (int numNodes, int n1, int n2, 
		      int * tcreated, int * tdestroyed);
//void checkPathDirect (const Protein * p_start, const Protein * p_end,
//float * backwardPathWeight, float * forwardPathWeight);
int  joinTheTreesForNodes (int n1, int n2, int numNodes);
void makeOneWayLink       (const int n1, const int n2, const float pW);
void addNode2Forest       (int count);
void initGivenStructures  (const char * relDir, 
			   int  * numNodes);
void createNodes (int * numberOfNodes, 
		  int numNodesAlreadySampled, int numNodes2Sample);

bool generateDecoy(int nodeIndex, const char * decoyFilename);
unsigned int computeTransitionProbabilities(Protein ** allNodes, int numNodes);
void createGaussianSampledNodes_OvermarsStyle(int * numberOfNodes, 
					      int numNodes2Sample);

void   checkPathDirect(const Protein * p_start, const Protein * p_end, 
		       vector <float> & E,
		       vector<vector<float> > & configs);
int linkNodesPCNN(const char * pcnnResultsFilename, 
		  int numberOfNodes, int maxNumLinks, int runIndex);

void connect(int nodeIndex, const vector<int> & neighbors, int numNodes);

void createNewNodesAndLink(int * numberOfNodes, const vector<Real> & pfolds, 
			   Protein ** allNodes, int numCenters, 
			   int numNodesAroundEachCenter, int k);
void clearAllLinks(int numNodes, Protein ** allNodes);
#endif
